#include <ctype.h>
#include <vector>
#include <iostream>
#include <fstream>
#include <string>
#include <map>
#include <stdlib.h>
using namespace std;

#include "vm.h"

int
main (int argc, char *argv[])
{
  if (argc < 2)
    {
      cout << "Usage: " << argv[0] << " input_file" << endl;
      exit (1);
    }
  setup_opcodes ();
  vector < char >m (memorysize);
  memory = &(m[0]);
  for (pass = 0; pass < 2; pass++)
    {
      current_address = 0;
      ifstream f (argv[1]);
      string s;
      unsigned int lineno = 0;
      try
      {
	while (getline (f, s))
	  {
	    lineno++;
	    for (unsigned int i = 0; i < s.length (); i++)
	      {
		if (s[i] == ';')
		{
		  s.erase(i,string::npos);
		  break;
		}
		  s[i] = tolower (s[i]);
	      }
	    analyze (s.c_str ());
	  }

	if (pass == 0)
	  {
	    instructions.resize (current_address);
	  }
      }
      catch (syntax_error & s)
      {
	cerr << "Syntax error in line " << lineno << endl;
	cerr << s.message<<endl;
	exit (1);
      }

    }
  execute ();
  exit (0);
};
